package EncodedTreeStore;
#
# $Id: EncodedTreeStore.pm,v 1.3 2002/12/18 08:56:24 white Exp $
#
use strict;
use TreeStore;
use vars qw(@ISA $AUTOLOAD);

@ISA = qw(TreeStore);

sub join_path{
    my($self) = @_;
    @_ = &TreeStore::__PARSEARG(@_);
    my $last = pop(@_);
    $last = &filenameEncode($last);
    push(@_,$last);
    $self->SUPER::join_path(@_);
}

sub read_dir{
    my($self) = shift;
    return grep {$_ = filenameDecode($_)} $self->SUPER::read_dir(@_);
}

sub filenameEncode{
    local($_) = @_;
    s/([\/\-\*\%\<\>\|])/sprintf("%%%02X",unpack("C", $1))/eg;
    return $_;
}

sub filenameDecode{
    local($_) = @_;
    s/\%([0-9A-Fa-f][0-9A-Fa-f])/pack("C", hex($1))/eg;
    return $_;
}
