package Yapw::Format;
use strict;

my $enableBlockElems;
my $enebleInlineBlockElems;
my $enableNonEmptyElems;
my %PATTERN =
(
 'URL' => '(?:(?:https?|ftp)://|mailto:)[\w;/?:@&=\+\$\.,\-!~\*\%\'\(\)\#]+',
 'ATWRITE' => '\[\@(?:\[.*?\]|[^\[\]]*?)+\]',
 'TABLE'   => '\[\#(?:\[.*?\]|[^\[\]]*?)+\]',
 'WikiName'=> '(?:[A-Z]+[a-z]+){2,}',
 'CR'      => '\r\n|\n|\r',
 'TEXT'    => '(?:^|\s|\G)(?:[\x00-\x7f]|[\x80-\xff][\x80-\xff])*?'
 );

my %ENABLE_ELEMS = 
(
 'Inline' => [qw(a em strong cite dfn code samp kbd var abbr acronym sub sup pre address tt i b s big small span del ins)],
 'Block'  => [qw(blockquote p pre dl ul ol h2 h3 h)],
 'Block_mustclose' => [qw(dt dd li div)],
 'InlineBlock' => [qw(del ins)],
 'Empty' => [qw(img br hr)]
 );

sub new{
    my $self = shift;
    my $class = ref($self) || $self;
    my $new = {
	'conf' => {
	    'elems'   => \%ENABLE_ELEMS,
	    'pattern' => \%PATTERN
	}
    };
    return bless $new,$class;
}

sub PATTERN{
    my $self = shift;
    my $type = shift;
    if($type eq 'Inline'){
	return join('|'
		    ,@{$self->{conf}->{elems}->{Inline}});
    }elsif($type eq 'Block'){
	return join('|'
		    ,@{$self->{conf}->{elems}->{Block}}
		    ,@{$self->{conf}->{elems}->{Block_mustclose}}
		    ,@{$self->{conf}->{elems}->{InlineBlock}});
    }elsif($type eq 'BlockMustClose'){
	return join('|'
		    ,@{$self->{conf}->{elems}->{Block_mustclose}});
    }elsif($type eq 'InlineBlock'){
	return join('|'
		    ,@{$self->{conf}->{elems}->{InlineBlock}});
    }elsif($type eq 'Empty'){
	return join('|'
		    ,@{$self->{conf}->{elems}->{Empty}});
    }elsif($type eq 'NonEmpty'){
	return join('|'
		    ,@{$self->{conf}->{elems}->{Inline}}
		    ,@{$self->{conf}->{elems}->{Block}}
		    ,@{$self->{conf}->{elems}->{Block_mustclose}}
		    ,@{$self->{conf}->{elems}->{InlineBlock}});
    }else{
	return sprintf('%s',$self->{'conf'}->{'pattern'}->{$type});
    }
}

1;
